let
  sources = import ./sources.nix;

  # declare pkgs from sources
  pkgs = import sources.nixpkgs { };
in sources // {
  nixpkgs = pkgs.applyPatches {
    src = sources.nixpkgs;
    name = "nixpkgs-patched";
    patches = [
      # stalwart-mail: 0.11.8 -> 0.12.0 
      (pkgs.fetchpatch {
        url = "https://github.com/NixOS/nixpkgs/pull/409178.patch";
        sha256 = "sha256-06J8pTjqeWTL6MJqVq17r3eelL5p/AfvUsPye5icVUg=";
      })
      # nixos/stalwart-mail: fix incorrect config for webadmin and spam-filter
      (pkgs.fetchpatch {
        url = "https://github.com/NixOS/nixpkgs/pull/412054.patch";
        sha256 = "sha256-OExslGsrGGPWSJJFPkZgYV8DaPKq9YDlmozPf/bV6dE=";
      })
      # headscale: 0.25.1 -> 0.26.0, update nixos module and test accordingly #407644
      (pkgs.fetchpatch {
        url = "https://github.com/NixOS/nixpkgs/pull/407644.patch";
        sha256 = "sha256-0fAB9DJ8KeocS/ZP4CPEt9VHkAu6gt025rSu3Skssqo=";
      })

      # # Revert "nixos/murmur: Get rid of global lib expansion" #413495 
      # (pkgs.fetchpatch {
      #   url = "https://github.com/NixOS/nixpkgs/pull/413495.patch";
      #   sha256 = "sha256-0QI2qn0vkFruk0sq15xLriz6iqvs2e9DjApVblsSULE=";
      # })
    ];
  };

  # nixpkgs = pkgs.lib.cleanSource /state/home/projects/nixos/nixpkgs;

  drasl = pkgs.applyPatches {
    src = sources.drasl;
    name = "drasl-patched";
    patches = [
      ./../patches/drasl-flakes-nix-add-option-package.patch
      ./../patches/drasl-registration-oidc-env.patch
      
    ];
  };
}
